function AIPlayer::driveBusTick( %this )
{
	cancel( %this.driveBusTick );

	if ( !isObject( %vehicle = %this.getObjectMount() ) )
	{
		%this.delete();
		return;
	}

	if ( $b )
	{
		%vehicle.delete();
		%this.delete();

		return;
	}

	if ( %this.getState() $= "Dead" )
	{
		%vehicle.delete();
		return;
	}

	%current = vectorLen( %vehicle.getVelocity() ) * 7000 / 3600;

	%speed = 50;
	%speed = %this.driveRespondNearby( %vehicle, %speed, %current );

	%float = mClampF( ( %current * 3600 / 7000 - 10 ) / 35, 0, 1 );

	%aheadDist = 5 + %float * ( 24 - 5 );
	%switchDist = 5 + %float * ( 16 - 5 );

	%node = getWord( %this.path, %this.index );
	%prev = getWord( %this.path, ( %this.index - 1 ) % %this.count );

	if ( vectorDist( %vehicle.position, %node.position ) <= %switchDist )
	{
		%this.index += 1;
		%this.index %= %this.count;

		%node = getWord( %this.path, %this.index );
		%prev = getWord( %this.path, ( %this.index - 1 ) % %this.count );
	}

	%diff = vectorNormalize( vectorSub( %prev.position, %node.position ) );

	%vhx = getWord( %vehicle.position, 0 );
	%vhy = getWord( %vehicle.position, 1 );

	%ndx = getWord( %node.position, 0 );
	%ndy = getWord( %node.position, 1 );

	%pvx = getWord( %prev.position, 0 );
	%pvy = getWord( %prev.position, 1 );

	if ( mAbs( getWord( %diff, 0 ) ) == 1 )
	{
		%om = 0;
		%oy = %ndy;
		%od = %vhy - %ndy;

		if ( %pvx > %ndx )
		{
			%ox = mClampF( %vhx - %aheadDist, %ndx, %pvx );
		}
		else
		{
			%ox = mClampF( %vhx + %aheadDist, %pvx, %ndx );
		}
	}

	if ( mAbs( getWord( %diff, 1 ) ) == 1 )
	{
		%om = 1;
		%ox = %ndx;
		%od = %vhx - %ndx;

		if ( %pvy > %ndy )
		{
			%oy = mClampF( %vhy - %aheadDist, %ndy, %pvy );
		}
		else
		{
			%oy = mClampF( %vhy + %aheadDist, %pvy, %ndy );
		}
	}

	%oz = getWord( %node.position, 2 );

	if ( mAbs( %od ) > 0.25 )
	{
		%this.setDriveDestination( %ox SPC %oy SPC %oz );
	}
	else
	{
		%this.setDriveDestination( %node.position );
	}

	%brake = ( %speed >= 0 ? %current - %speed : %speed - %current ) >= 1 || mAbs( %speed ) <= 1;

	if ( %brake )
	{
		%this.setMoveY( 0 );
	}
	else
	{
		%max = %vehicle.getDataBlock().maxWheelSpeed * 7000 / 3600;
		%val = mClampF( %speed / %max, -1, 1 );

		%this.drivingReverse = %val < 0;
		%this.setMoveY( %val );
	}

	%this.driveBusTick = %this.schedule( 50, "driveBusTick" );
}