function findPath( %start, %end, %max, %avoid_node, %avoid_from )
{
	if ( !isObject( %start ) || !isObject( %end ) )
	{
		return "error";
	}

	if ( !strLen( %max ) )
	{
		%max = 128;
	}

	if ( isObject( %avoid_node ) && isObject( %avoid_from ) )
	{
		%avoid_node = %avoid_node.getID();
		%avoid_from = %avoid_from.getID();

		if ( !isEventPending( %avoid_node.fixColor ) )
		{
			%avoid_node.fixColor = %avoid_node.schedule( 1000, "setColor", %avoid_node.colorId );
			%avoid_node.setColor( 0 );
		}

		if ( !isEventPending( %avoid_from.fixColor ) )
		{
			%avoid_from.fixColor = %avoid_from.schedule( 1000, "setColor", %avoid_from.colorId );
			%avoid_from.setColor( 1 );
		}

		// %avoid_from.fakeKillBrick( "0 0 5", 3 );
	}
	else
	{
		%avoid_node = "";
		%avoid_from = "";
	}

	%start = %start.getID();
	%end = %end.getID();

	if ( %start == %end )
	{
		return %start SPC %end;
	}

	%opened = %start;
	%closed = "";
	%pathed = "";

	%g_score[ %start ] = 0;
	%f_score[ %start ] = pathCost( %start, %end );

	%iterations = 0;

	while ( %len = getWordCount( %opened ) && %iterations < %max )
	{
		%iterations++;

		%node = "";
		%best = "";

		for ( %i = 0 ; %i < %len ; %i++ )
		{
			%test = getWord( %opened, %i );

			if ( %f_score[ %test ] < %best || !strLen( %best ) )
			{
				%node = %test;
				%best = %f_score[ %test ];
			}
		}

		if ( %node == %end )
		{
			return retraceSteps( %pathed, %end );
		}

		%opened = ct_list_del( %opened, %node );
		%closed = ct_list_add( %closed, %node );

		for ( %i = 0 ; %i < %node.neighbors ; %i++ )
		{
			%neighbor = %node.neighbor[ %i ];

			if ( %avoid_from !$= "" && %node == %avoid_from && %neighbor == %avoid_node )
			{
				continue;
			}

			if ( ct_list_has( %closed, %neighbor ) )
			{
				continue;
			}

			%tent_g_score = %g_score[ %node ] + pathCost( %node, %neighbor );

			if ( !ct_list_has( %opened, %neighbor ) || %tent_g_score <= %g_score[ %neighbor ] )
			{
				%pathed = ct_map_set( %pathed, %neighbor, %node );

				%g_score[ %neighbor ] = %tent_g_score;
				%f_score[ %neighbor ] = %tent_g_score + pathCost( %neighbor, %end );

				if ( !ct_list_has( %opened, %neighbor ) )
				{
					%opened = ct_list_add( %opened, %neighbor );
				}
			}
		}
	}

	return "error";
}

function retraceSteps( %pathed, %node )
{
	%value = ct_map_get( %pathed, %node );

	if ( strLen( %value ) )
	{
		return ct_list_add( retraceSteps( %pathed, %value ), %node );
	}
	else
	{
		return %node;
	}
}

function pathCost( %a, %b )
{
	return vectorDist( %a.position, %b.position );
}