package road_neighbor_package
{
	function fxDTSBrickData::onPlant( %this, %obj )
	{
		parent::onPlant( %this, %obj );

		%name = %this.getName();
		%road = %name $= "brick32x32froadsData" ||
				%name $= "brick32x32froadtData" ||
				%name $= "brick32x32froadcData" ||
				%name $= "brick32x32froadxData";

		if ( !%road )
		{
			return;
		}

		%this.onRoadPlant( %obj );
	}

	function fxDTSBrickData::onLoadPlant( %this, %obj )
	{
		parent::onLoadPlant( %this, %obj );

		%name = %this.getName();
		%road = %name $= "brick32x32froadsData" ||
				%name $= "brick32x32froadtData" ||
				%name $= "brick32x32froadcData" ||
				%name $= "brick32x32froadxData";

		if ( !%road )
		{
			return;
		}

		%this.onRoadPlant( %obj );
	}

	function fxDTSBrickData::onRemove( %this, %obj )
	{
		parent::onRemove( %this, %obj );

		while ( %obj.neighbors )
		{
			%obj.removeNeighbor( %obj.neighbor[ 0 ] );
		}
	}
};

activatePackage( "road_neighbor_package" );

function fxDTSBrickData::onRoadPlant( %this, %obj )
{
	roadGroup.add( %obj );

	for ( %x = -1 ; %x <= 1 ; %x++ )
	{
		for ( %y = -1 ; %y <= 1 ; %y++ )
		{
			%diff = %x * 16 SPC %y * 16 SPC 0;

			if ( vectorLen( %diff ) != 16 )
			{
				continue;
			}

			%ray = containerRayCast( %obj.position, vectorAdd( %obj.position, %diff ), $TypeMasks::FxBrickObjectType, %obj );
			%col = firstWord( %ray );

			if ( !isObject( %col ) )
			{
				continue;
			}

			if ( vectorSub( %col.position, %obj.position ) !$= %diff )
			{
				continue;
			}

			if ( !checkRoadLink( %x SPC %y, %this.getName(), %obj.angleId ) )
			{
				continue;
			}

			if ( !checkRoadLink( -%x SPC -%y, %col.getDataBlock().getName(), %col.angleId ) )
			{
				continue;
			}

			%obj.addNeighbor( %col );
		}
	}
}

function checkRoadLink( %dir, %name, %angle )
{
	%dirs = getRoadDirs( %name, %angle );

	if ( strLen( %dirs ) )
	{
		%count = getFieldCount( %dirs );

		for ( %i = 0 ; %i < %count ; %i++ )
		{
			if ( getField( %dirs, %i ) $= %dir )
			{
				return true;
			}
		}
	}

	return false;
}

function getRoadDirs( %name, %angle )
{
	if ( %name $= "brick32x32froadsData" )
	{
		if ( %angle % 2 == 0 )
		{
			return "0 1\t0 -1";
		}
		else
		{
			return "1 0\t-1 0";
		}
	}

	if ( %name $= "brick32x32froadtData" )
	{
		switch$ ( %angle )
		{
			case 0: return "1 0\t0 1\t0 -1";
			case 1: return "0 -1\t1 0\t-1 0";
			case 2: return "-1 0\t0 1\t0 -1";
			case 3: return "0 1\t1 0\t-1 0";
		}
	}

	if ( %name $= "brick32x32froadcData" )
	{
		switch$ ( %angle )
		{
			case 0: return "1 0\t0 -1";
			case 1: return "-1 0\t0 -1";
			case 2: return "-1 0\t0 1";
			case 3: return "1 0\t0 1";
		}
	}

	if ( %name $= "brick32x32froadxData" )
	{
		return "1 0\t-1 0\t0 1\t0 -1";
	}
}