function angleDif( %a, %b )
{
	%v = %a - %b;

	if ( %v < ( -1 * $pi ) )
	{
		%v += $m2pi;
	}

	if ( %v > $pi )
	{
		%v -= $m2pi;
	}

	return %v;
}

function getAngleDifference( %a, %b )
{
	%va = %a.getForwardVector();
	%vb = vectorSub( %b.position, %a.position );

	%aa = mATan( getWord( %va, 1 ), getWord( %va, 0 ) );
	%ab = mATan( getWord( %vb, 1 ), getWord( %vb, 0 ) );

	return angleDif( %ab, %aa );
}

function vectorToAxis( %vec )
{
	%x = getWord( %vec, 0 );
	%y = getWord( %vec, 1 );

	%yawAng = mAtan( %x, %y );

	if( %yawAng < 0.0 )
	{
		%yawAng += $pi*2;
	}

	%rot = "0 0 1" SPC %yawAng;

	return %rot;
}

function AIPlayer::setDriveDestination( %this, %dest )
{
	if ( %this.driveDestination !$= %dest )
	{
		%this.schedule( 0, "driveEvent" );
	}

	%this.driveDestination = %dest;
}

function AIPlayer::driveEvent( %this )
{
	%this.setMoveX( 0 );
	%this.setMoveX( 0.1 );

	cancel( %this.driveEvent );

	%vh = %this.getControlObject();
	%dif = 0;

	if ( strLen( %dest = %this.driveDestination ) )
	{
		%curr = %vh.getForwardVector();
		%targ = vectorSub( %dest, %vh.getPosition() );

		%at = mATan( getWord( %targ, 1 ), getWord( %targ, 0 ) );
		%af = mATan( getWord( %curr, 1 ), getWord( %curr, 0 ) );

		%dif = angleDif( %af, %at );
	}

	if ( %this.drivingReverse )
	{
		%dif *= -1;
	}

	%vh.setWheelSteering( 0, %dif );
	%vh.setWheelSteering( 1, %dif );

	%this.driveEvent = %this.schedule( 50, "driveEvent" );
}

// Lists

function ct_list_add( %list, %item )
{
	return %list @ ( strLen( %list ) ? " " : "" ) @ %item;
}

function ct_list_has( %list, %item )
{
	return striPos( " " @ %list @ " ", " " @ %item @ " " ) >= 0;
}

function ct_list_del( %list, %item )
{
	%list = strReplace( " " @ %list @ " ", " " @ %item @ " ", " " );

	if ( strLen( %list ) == 1 )
	{
		return "";
	}

	return getSubStr( %list, 1, strLen( %list ) - 1 );
}

// Maps

function ct_map_set( %map, %key, %value )
{
	%count = getFieldCount( %map );

	for ( %i = 0 ; %i < %count ; %i++ )
	{
		if ( %i % 2 == 1 )
		{
			continue;
		}

		if ( getField( %map, %i ) $= %key )
		{
			return setField( %map, %i + 1, %value );
		}
	}

	return %map @ ( strLen( %map ) ? "\t" : "" ) @ %key TAB %value;
}

function ct_map_get( %map, %key )
{
	%count = getFieldCount( %map );

	for ( %i = 0 ; %i < %count ; %i++ )
	{
		if ( %i % 2 == 1 )
		{
			continue;
		}

		if ( getField( %map, %i ) $= %key )
		{
			return getField( %map, %i + 1 );
		}
	}
}